﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Threading.Tasks;

namespace Modèle
{
    [DataContract]
    public class Utilisateur : Personne
    {
        [DataMember]
        public int NbSubmit { get; private set; }
        public Utilisateur(string mail, string mdp): base(mail, mdp)
        {
            NbSubmit = 0;
        }
        public Utilisateur(string mail, string mdp, int nbSubmit): base(mail, mdp) 
        {
            NbSubmit = nbSubmit;
        }

        public override string ToString()
        {
            return Email + " " + MotDePasse + " " + NbSubmit;
        }


        public bool Equals(Utilisateur u)
        {
            return Email == u.Email;
        }


        public override void AjouterRequin(Requin req, ObservableCollection<Requin> requins)
        {
            requins.Add(req);
            NbSubmit++;
        }
    }
}
