﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using Modèle;
using Persistance;

namespace StubLib
{
    public class Stub : IPersistanceManager
    {

        private List<Requin> requins = new List<Requin>();
        private List<Requin> requinsEdit = new List<Requin>();
        private List<Requin> requinsAdd = new List<Requin>();

        private List<Utilisateur> utilisateurs = new List<Utilisateur>();
        private List<Expert> expert = new List<Expert>();

        public Stub()
        {
            // Requins
            List<Zone> zone = new List<Zone> { Zone.ATLANTIQUE };
            List<Zone> zone2 = new List<Zone> { Zone.PACIFIQUE };
            requins.Add(new Requin("mon requin adoré", "trop cool ce requin", "wow il est trop bo", "Images/Dormeur-Mexicain.png", "Videos/Vid-dormeur-mexicain.mp4", "Images/rep_Heterodontus_mexicanus.png", Conservation.EW, zone, "(C'est pas un vrai requin)"));
            requins.Add(new Requin("Banane", "Le requin banal", "C'est un requin ultra banal", "Images/White_shark.png", "Videos/Vid-Requin-Blanc.mp4", "Images/rep_Heterodontus_mexicanus.png", Conservation.LC, zone, "Il est pas aussi banal qu'il en a l'air"));
            requins.Add(new Requin("Req1", "Le requin pas banal", "C'est un requin pas ultra banal", "Images/White_shark.png", "Videos/Vid-dormeur-mexicain.mp4", "Images/rep_Heterodontus_mexicanus.png", Conservation.EX, zone2, "Il est vraiment pas banal"));
            requinsAdd.Add(new Requin("leRequinAjouté", "Le requin pas banal", "C'est un requin pas ultra banal", "Images/White_shark.png", "Videos/Vid-dormeur-mexicain.mp4", "Images/rep_Heterodontus_mexicanus.png", Conservation.EX, zone2, "Il est vraiment pas banal"));
            requinsAdd.Add(new Requin("leDeuxièmeRequinAjouté", "Le requin vraiemnt pas banal", "C'est un requin vraiment pas ultra banal", "Images/White_shark.png", "Videos/Vid-dormeur-mexicain.mp4", "Images/rep_Heterodontus_mexicanus.png", Conservation.EX, zone2, "Il est vraiment vraiment pas banal"));
            requinsEdit.Add(new Requin("Banane", "Le requin banal", "C'est un requin ultra banal", "Images/White_shark.png", "Videos/Vid-Requin-Blanc.mp4", "Images/rep_Heterodontus_mexicanus.png", Conservation.EW, zone, "En fait il est giga banal"));
            requinsAdd.Add(new Requin("leTroisièmeRequinAjouté", "Le requin pas banal", "C'est un requin pas ultra banal", "Images/White_shark.png", "Videos/Vid-dormeur-mexicain.mp4", "Images/rep_Heterodontus_mexicanus.png", Conservation.EX, zone2, "Il est vraiment pas banal"));
            requinsAdd.Add(new Requin("leQuatrièmeRequinAjouté", "Le requin vraiemnt pas banal", "C'est un requin vraiment pas ultra banal", "Images/White_shark.png", "Videos/Vid-dormeur-mexicain.mp4", "Images/rep_Heterodontus_mexicanus.png", Conservation.EX, zone2, "Il est vraiment vraiment pas banal"));
            // Utilisateurs
            utilisateurs.Add(new Utilisateur("a", "salut"));
            expert.Add(new Expert("salut", "hey", "bob"));
            
        }

        public (List<Requin> reqs, List<Requin> reqsAdd, List<Requin> reqsEdit) LoadRequins()
        {
            return (new List<Requin>(requins), new List<Requin>(requinsAdd), new List<Requin>(requinsEdit));
        }

        public void SaveRequins(List<Requin> reqs, List<Requin> reqsAdd, List<Requin> reqsEdit)
        {
            requins = reqs;
            requinsAdd = reqsAdd;
            requinsEdit = reqsEdit;
        }

        public (List<Utilisateur> users, List<Expert> experts) LoadUsers()
        {
            return (new List<Utilisateur>(utilisateurs), new List<Expert>(expert));
        }

        public void SaveUsers(List<Utilisateur> users, List<Expert> experts)
        {
            utilisateurs = users;
            expert = experts;
        }
    }
}
